//
//     Copyright (C) 2006 - 2007 SophiaCradle, Inc.
//     All rights reserved.
//
//      AlarmSettingDialog.hpp
//

#ifndef __ALARMSETTINGDIALOG_HPP
#define __ALARMSETTINGDIALOG_HPP

#include <SophiaFramework.hpp>
#include "SGRNumberTextControl.hpp"
#include "DateSelectionDialog.hpp"

SFMTYPEDEFCLASS(AlarmSettingDialog)

class AlarmSettingDialog : public SFRTitleDialog {

    SFMSEALCOPY(AlarmSettingDialog)

private:

    SFRComboboxControlPtr _onOff;
    SFREditboxControlPtr _subject;
    SFRButtonControlPtr _date;
    SGRNumberTextControlPtr _hour;
    SGRNumberTextControlPtr _minute;
    DateSelectionDialogPtr _dateDialog;
    SFXDateDuration _timeDifference;
    SFXDate _alarmLocalDate;
    SFXRectangle _onOffTextRect;
    SFXRectangle _onOffControlRect;
    SFXRectangle _subjectTextRect;
    SFXRectangle _subjectControlRect;
    SFXRectangle _dateTextRect;
    SFXRectangle _dateControlRect;
    SFXRectangle _timeTextRect;
    SFXRectangle _hourControlRect;
    SFXRectangle _hourTextRect;
    SFXRectangle _minuteControlRect;
    SFXRectangle _minuteTextRect;

public:

    explicit AlarmSettingDialog(SFXDateDurationConstRef timeDifference = SFXDateDuration(9 * 3600)) static_throws;
    virtual ~AlarmSettingDialog(Void);
    HANDLER_DECLARE_VOIDRENDER(OnContent)
    HANDLER_DECLARE_BOOLVOID(OnSelect)
    HANDLER_DECLARE_VOIDCONTROL(OnEditbox)
    HANDLER_DECLARE_VOIDCONTROL(OnAlarmCombo)
    HANDLER_DECLARE_VOIDCONTROL(OnDateButton)
    HANDLER_DECLARE_VOIDEVENT(OnDateSelectionDialog)
    HANDLER_DECLARE_VOIDEVENT(OnSoftkey)
    HANDLER_DECLARE_VOIDDIALOG(OnErrorDialog)
};

#endif
