//
//     Copyright (C) 2006 - 2007 SophiaCradle, Inc.
//     All rights reserved.
//
//      CityAdditionDialog.hpp
//

#ifndef __CITYADDITIONDIALOG_HPP
#define __CITYADDITIONDIALOG_HPP

#include <SophiaFramework.hpp>

SFMTYPEDEFCLASS(CityAdditionDialog)

class CityAdditionDialog : public SFRTitleDialog {

SFMSEALCOPY(CityAdditionDialog)

private:

    SFREditboxControlPtr _nameControl;
    SFREditboxControlPtr _timeDifferenceControl;
    SFREditboxControlPtr _latitudeControl;
    SFREditboxControlPtr _longitudeControl;
    SFREditboxControlPtr _heightControl;
    SFXRectangle _nameLabelRect;
    SFXRectangle _nameControlRect;
    SFXRectangle _timeDifferenceLabelRect;
    SFXRectangle _timeDifferenceControlRect;
    SFXRectangle _latitudeLabelRect;
    SFXRectangle _latitudeControlRect;
    SFXRectangle _longitudeLabelRect;
    SFXRectangle _longitudeControlRect;
    SFXRectangle _heightLabelRect;
    SFXRectangle _heightControlRect;

public:

    SFMTYPEDEFSTRUCT(NewCityData)
    struct NewCityInformation {
        SFXWideString _name;
        SFXWideString _timeDifference;
        SFXWideString _longitude;
        SFXWideString _latitude;
        SFXWideString _height;
        SFXWideString _errorMessage;
        SFREditboxControlPtr _invalidControl;
    };

public:

    CityAdditionDialog(SFXWideStringConstRef name, SFXWideStringConstRef timeDifference, SFXWideStringConstRef longitude, SFXWideStringConstRef latitude, SFXWideStringConstRef height) static_throws;
    virtual ~CityAdditionDialog(Void);
    NewCityInformation GetNewCityInformation(Void) const;
    HANDLER_DECLARE_VOIDRENDER(OnContent)
    HANDLER_DECLARE_BOOLVOID(OnSelect)
    HANDLER_DECLARE_VOIDCONTROL(OnEditbox)
};

#endif
