//
//     Copyright (C) 2006 - 2007 SophiaCradle, Inc.
//     All rights reserved.
//
//      CitySelectionDialog.hpp
//

#ifndef __CITYSELECTIONDIALOG_HPP
#define __CITYSELECTIONDIALOG_HPP

#include <SophiaFramework.hpp>
#include "SGRListboxControl.hpp"
#include "CityAdditionDialog.hpp"

SFMTYPEDEFCLASS(CitySelectionDialog)

class CitySelectionDialog : public SFRTitleDialog
{

SFMSEALCOPY(CitySelectionDialog)

private:

    SGRListboxControlPtr _listBox;
    CityAdditionDialogPtr _additionDialog;
    SFRMessageDialogPtr _gpsDialog;
    SFREditboxControlPtr _invalidTextControl;
    SFXRectangle _textRect;
    SFXRectangle _listBoxRect;
    SFBPosDetSmp _posDet;
    AEEGPSInfo _gpsInfo;
    SFXCallback _gpsCallback;

public:

    CitySelectionDialog(Void) static_throws;
    virtual ~CitySelectionDialog(Void);
    SInt32 GetSelect(Void) const;

private:

    CALLBACK_DECLARE_SFXCALLBACK(OnGPSNotify)
    Void OnGPS(Bool valid);
    HANDLER_DECLARE_VOIDRENDER(OnContent)
    HANDLER_DECLARE_VOIDEVENT(OnSoftkey)
    HANDLER_DECLARE_VOIDEVENT(OnAdditionDialogSoftKey)
    HANDLER_DECLARE_VOIDDIALOG(OnErrorDialog)
    HANDLER_DECLARE_VOIDDIALOG(OnRemoveErrorDialog)
    HANDLER_DECLARE_VOIDDIALOG(OnRemoveDialog)
    HANDLER_DECLARE_BOOLEVENT(OnNoButtonDialogKey)
    HANDLER_DECLARE_VOIDEVENT(OnNoButtonDialogSoftkey)
    HANDLER_DECLARE_VOIDRESUME(OnResume)
    HANDLER_DECLARE_VOIDSUSPEND(OnSuspend)
};

inline SInt32 CitySelectionDialog::GetSelect(Void) const
{
    return _listBox ? static_cast<SInt32>(_listBox->GetSelect()) : 0;
}

#endif
