//
//     Copyright (C) 2006 - 2007 SophiaCradle, Inc.
//     All rights reserved.
//
//      ClockWindow.hpp
//

#ifndef __CLOCKWINDOW_HPP
#define __CLOCKWINDOW_HPP

#include <SophiaFramework.hpp>
#include "ClockPane.hpp"
#include "AstronomyPane.hpp"
#include "CalendarPane.hpp"
#include "CitySelectionDialog.hpp"

SFMTYPEDEFCLASS(ClockWindow)

class ClockWindow : public SFRPlainWindow {

    SFMSEALCOPY(ClockWindow)

private:

    Bool _calendarShowing;
    ClockPanePtr _clock;
    AstronomyPanePtr _astronomy;
    CalendarPanePtr _calendar;
    CitySelectionDialogPtr _cityDialog;

    Bool _simulation;
    SFXDate _simulationDate;
    SFXWideString _cityName;
    SFXDateDuration _timeDifference;
    Float64 _longitude;
    Float64 _latitude;
    Float64 _height;
    SFXRectangle _clockRect;
    SFXRectangle _astronomyRect;
    SFXRectangle _calendarRect;
    enum Softkey2MenuEnum {
        SOFTKEY2_OPERATION_CITY = 0,
        SOFTKEY2_OPERATION_ALARM,
        SOFTKEY2_OPERATION_VERSION,
        SOFTKEY2_OPERATION_LIMIT
    };

public:

    ClockWindow(SFRApplicationPtr parent, SFXRectangleConstRef rect, SFXWideStringConstRef cityName, SFXDateDurationConstRef timeDifference, Float64 longitude, Float64 latitude, Float64 height) static_throws;
    virtual ~ClockWindow(Void);

    Void SetCity(SFXWideStringConstRef cityName, SFXDateDurationConstRef timeDifference, Float64 longitude, Float64 latitude, Float64 height);
    HANDLER_DECLARE_VOIDRESUME(OnAppResume)
    HANDLER_DECLARE_VOIDEVENT(OnSoftkey)
    HANDLER_DECLARE_BOOLEVENT(OnKey)
    HANDLER_DECLARE_VOIDMENU(OnSoftkey2Menu)
    HANDLER_DECLARE_BOOLEVENT(OnCityDialogKey)

private:

    Void ShowAstronomy(Void) static_throws;
    Void ShowCalendar(Void) static_throws;
};

#endif
