//
//     Copyright (C) 2006 - 2007 SophiaCradle, Inc.
//     All rights reserved.
//
//      DateSelectionDialog.hpp
//

#ifndef __DATESELECTIONDIALOG_HPP
#define __DATESELECTIONDIALOG_HPP

#include <SophiaFramework.hpp>
#include "SGRCalendarControl.hpp"

SFMTYPEDEFCLASS(DateSelectionDialog)

class DateSelectionDialog : public SFRTitleDialog {

    SFMSEALCOPY(DateSelectionDialog)

private:

    SGRCalendarControlPtr _calendar;

public:

    explicit DateSelectionDialog(SFXDateConstRef date, SFXDateDurationConstRef timeDifference = SFXDateDuration(9 * 3600), SGRCalendarControl::YearFormatEnum yearFormat = SGRCalendarControl::YEARFORMAT_AD, SGRCalendarControl::MonthFormatEnum monthFormat = SGRCalendarControl::MONTHFORMAT_ENGLISH, SGRCalendarControl::DayFormatEnum dayFormat = SGRCalendarControl::DAYFORMAT_ENGLISH, Bool beginMonday = false) static_throws;
    virtual ~DateSelectionDialog(Void);

    SFXDate GetCursor(Void) const;
    HANDLER_DECLARE_BOOLEVENT(OnKey)
    HANDLER_DECLARE_VOIDEVENT(OnSoftkey)

private:

    static SFXRectangle ComputeWindowRectangle(Void);
};

inline SFXDate DateSelectionDialog::GetCursor(Void) const
{
    SFXDate cursor(_calendar ? _calendar->GetCursor() : SFXDate::CurrentDate());
    SFXDate result(cursor.GetYear(), cursor.GetMonth(), cursor.GetDay(), 0, 0, 0);
    return result;
}

#endif
