//
//     Copyright (C) 2006 - 2007 SophiaCradle, Inc.
//     All rights reserved.
//
//      SGRListboxControl.hpp
//

#ifndef __SGRLISTBOXCONTROL_HPP
#define __SGRLISTBOXCONTROL_HPP

#include <SophiaFramework.hpp>

SFMRESPONDERTYPE(LISTBOXCONTROL, TYPE_SFRCONTROL)
SFMRESPONDERATTRIBUTE(LISTBOXCONTROL, four_char_code('L', 'i', 's', 't'))
SFMRESPONDERBEHAVIOR(LISTBOXCONTROL, BEHAVIOR_SFRCONTROL, PROPERTY_DIRECT, PROPERTY_TRAVEL | PROPERTY_SCROLLABLE)

SFMTYPEDEFCLASS(SGRListboxControl)

class SGRListboxControl : public SFRControl {

    SFMSEALCOPY(SGRListboxControl)

private:

    SFXArray<SFXAnsiStringPtr> _item;
    SInt16 _limit;
    SInt16 _select;
    SInt16 _offset;
    SInt16 _speed;
    SInt16 _height;
    SInt16 _field;
    SInt16 _delta;
    SInt16 _interval;
    SInt16 _firstinterval;
    SInt16 _drawWidth;
    SFXTimer _timer;

public:

    explicit SGRListboxControl(SFRResponderPtr responder, SFXRectangleConstRef rect) static_throws;
    virtual ~SGRListboxControl(Void);
    SInt16 GetItemCount(Void) const;
    Void SetSelect(SInt16 value);
    SInt16 GetSelect(Void) const;
    Void SetDelta(SInt16 value);
    SInt16 GetDelta(Void) const;
    Void SetInterval(SInt16 interval);
    SInt16 GetInterval(Void) const;
    Void SetFirstInterval(SInt16 interval);
    SInt16 GetFirstInterval(Void) const;
    Void SetSpeed(SInt16 speed);
    SInt16 GetSpeed(Void) const;
    SFCError Append(SFXAnsiStringConstRef item);
    Void Remove(SInt16 index);
    Void Clear(Void);

private:

    HANDLER_DECLARE_BOOLEVENT(OnKey)
    HANDLER_DECLARE_VOIDRENDER(OnBase)
    HANDLER_DECLARE_VOIDRENDER(OnContent)
    HANDLER_DECLARE_VOIDRESUME(OnResume)
    HANDLER_DECLARE_VOIDSUSPEND(OnSuspend)
    Void RefreshDelta(Void);
    Void DrawItem(SFXGraphicsPtr graphics, SFXRectangleConstRef rect, SInt16 index, Bool next, Bool previous, SInt16 offset);
    static SInt16 DrawTriangle(SFXGraphicsPtr graphics, SFXRectangleConstRef rect, Bool figure, SFXRGBColorConstRef color);
    CALLBACK_DECLARE_SFXTIMER(OnTimer)
    Void StartTimer(Void);
    Void StopTimer(Void);
    Void RestartTimer(Void);
};

#endif // __SGRLISTBOXCONTROL_HPP //
